Just grabbing docs and making notes for now, will convert to true Markdown later.


    """
    Exception classes:
    <fill this in with the exception classes that we build for this.>

    Functions:
    <list all the functions>

    How To Use This Module
    ======================
    1. Import it
    2. <fill in as we progress>


    The master object

    Proposed attributes (from outline on whiteboard that we took a photo of and posted to Slack):
    
    dataset (type: DTData) -- a DTData object
    model (type: DTModel) -- actually, could be a DTModel or an object subclassed from DTModel (e.g. we may want to have different subtypes of models)
    what_to_save (type: string, or list of strings?) -- one or more signifiers of what output we want to save... presumably this would be things like 
        'accuracies' and/or 'aucs' (area under ROC curves) and/or 'confusion_matrices' and/or 'all_outputs' (e.g. all the scores produced by the 
        classifier), and/or so on. This attribute might end splitting into more than one attribute, or maybe something like a dictionary, potentially?
        E.g. a series of Boolean flags, or certain outputs might require additional arguments -- for example, what filetype to use when saving output
        (CSV vs tab-delimited text aka TSV vs JSON vs whatever).
    output_file (type: string) -- what to call the output file. Will have to see how this goes in implementation -- it might be better to just make 
        it the first part of an output filename (e.g. if there are multiple outputs, you might have 'my_output_accuracies.csv' and 'my_output_aucs.csv'
        and so on). Or we could switch this over to being the name of a directory to save the output in, if we decide we're pretty much always going 
        to have multiple output files. Or we could make file-vs-directory yet another user-configurable option.
    nits (type: integer) -- number of iterations to run, i.e. number of times to train/test the model, throw it out, initialize a new model, re-divvy 
        up the data into different training/validation/test sets, and run again. Some decisions will have to be made as to how to treat this attribute 
        for different analysis types -- for example, if we are doing classification on a per-subject basis, do we do all the iterations for each 
        subject first and then do the same number of iterations for the next subject, or do we do one iteration for each subject and then do a second 
        pass through all the subjects, etc.? Or make this configurable as well?
    type (type: string) -- what overall class of analysis to run. Some basic examples could be 'universal' (across all subjects), 'subject_wise' 
        (train and test a separate model for each subject), 'transfer' (train on a subset of the data and then lop off part of the classifier and 
        re-train on the remaining data), or maybe others. Some of these (e.g. 'transfer') might have to be something like a dictionary (with more 
        options specified inside) rather than just a simple string. Or we could always have the option to pass in something like a function handle 
        if the user has something more exotic in mind, and that function would figure out what to do. (The same goes for a lot of the options above, 
        actually... a good fallback plan for many of them might be to allow a handle to a function with a given specification to be passed in, so 
        the user can always overload most of the default functionalities pretty easily while still using our basic framework.)
    t_v_t (type: tuple of integers/floats) -- percentages of data to use as training, validation, and test datasets, respectively. Actually, no need 
        for these to be percentages per se... they could just be relative values expressing the ratios of those sets. So, for example, (80, 10, 10) 
        and (8, 1, 1) and (4, .5, .5) would all represent the same thing, 80% training, 10% validation, 10% test. No need to make the user do the 
        percent math if they want to think ratio-wise. Presumably, the validation and test numbers could be zero, either if we don't want to hold out
        a test dataset for some reason, or if validation is not a concept that makes sense for the classifier in question. (E.g. an SVM would probably
        just have train/test.) This attribute might be ignored for certain values of 'xval_type' below because it doesn't really make sense with all 
        of them.
    xval_type (type: string) -- cross-validation scheme. For example, 'kfold_rand' to do k-fold cross-validation with random selection of folds (this 
        presumably makes more sense for simple classifiers that just need train/test data... would have to figure out how to interpret this with 
        validation in the mix... also we might need an additional parameter or to make this a dictionary or something in order to indicate the # of 
        folds), 'single' to just do a single (randomized) divvying-up of training/validation/test in each iteration, 'kfold_session' to train/test (and 
        maybe validate) across some kind of session-like natural division in the data (e.g. runs in fMRI, or could be something like subjects... we may 
        need an additional parameter or to make this attribute a dictionary so we can specify exactly which labels in the data we want to treat as the 
        'session' variable).
    
    Proposed methods:
    
    run() -- the most important one. Runs the analysis and does pretty much everything. We haven't gotten much beyond this but presumably implementing 
        it will entail creating a bunch of other helper methods, some of which will make sense to make user-accessible. For example, one we wrote down 
        was check_already_ran(), which would presumably look for the specified output and see if it appeared that the analysis in question had already 
        happened. (This could be useful in implementing a batch system -- e.g. if a batch runs through a bunch of analyses but then crashes or gets 
        interrupted somehow, you don't want to have to manually check where to resume... you'd rather just start the batch running again and let it 
        figure out where it left off.)
    validate_arguments() -- all major classes will need one of these to help DTBatch decide if batch file structures are valid. Takes in a dict of 
        keys/values, which are presumed to represent input arguments to this class's initializer. Returns True if valid and False if not.
    
    
    """