# delineate.py #

---

The current main entry point into the toolbox if you are using a JSON-based job configuration file (as opposed to loading the modules manually and writing your own Python code).

This script is currently very simple. It takes in one or more JSON files with job configurations, instantiates a DTJob object based on each one, and runs each DTJob in turn. Everything else is handled by the rest of the toolbox.

See the main **README.md** file for some details on the JSON job file format.

<br><br>



## Usage ##

**python delineate.py my\_first\_job.json [my\_second\_job.json] [my\_third\_job.json] ...**

**python**: Can be either Python 2 or 3 (but see README.md for compatibility details).

**delineate.py**: This script. Note if you are not inside the main DeLINEATE directory when running the script, you would need to specify the full pathname, e.g.

> `python ~/delineate_toolbox_dir/delineate.py my_first_job.json`

**my\_first\_job.json** (etc.): JSON-formatted job files; any number can be specified and the script will run them in sequence. If one of them encounters an error (including incorrect JSON formatting), the current functionality is for the whole script to terminate without running subsequent jobs. However, if the user manually interrupts running (e.g. with Control-C), the script will continue with the next job in the sequence. This is useful if, for example, you have a whole bunch of models queued up and you see that one is not working very well -- in that case, you can just terminate the current analysis manually and have the script move on to the next one.

For those who care about the implementation details, note that what this script will do is create a `DTJob` object out of each file specified on the command line. The JSON-format job config files can contain either a single job specification or a list of such specifications, but either way, this script does not concatenate the files or anything like that. So if you specify three files with two jobs each in them, this script will create three `DTJob` objects, each containing a list of two jobs. This detail shouldn't really matter to the end user unless you're using this code as a template to write your own script.
